#!/usr/bin/env ruby
# -*- coding: utf-8 -*-
#
# グラフ描画ライブラリAlGraphサンプル
#

require "al_template"
require "al_form"
require "./line_plot"
require "./bar_plot"
require "./pie_chart"
require "./scatter_plot"

class AlControllerGraph < AlController
  #
  # デフォルトアクション
  #
  def action_index()
    AlTemplate.run("index.rhtml")
  end

  #
  # 折れ線グラフサンプル
  #
  def action_line_plot()
    AlTemplate.run("line_plot.rhtml")
  end

  #
  # 棒グラフサンプル
  #
  def action_bar_plot
    AlTemplate.run("bar_plot.rhtml")
  end

  #
  # 円グラフサンプル
  #
  def action_pie_chart
    AlTemplate.run("pie_chart.rhtml")
  end

  #
  # 散布図サンプル
  #
  def action_scatter_plot
    AlTemplate.run("scatter_plot.rhtml")
  end


  #
  # ソースコードビューア
  #
  def action_view_source
    part = AlForm.get_parameter( AlText.new("part") )
    return if /^([a-z]+)_/ !~ part

    target = { line: "line_plot.rb",
               bar: "bar_plot.rb",
               pie: "pie_chart.rb",
               scatter: "scatter_plot.rb" }[$1.to_sym]

    Alone::add_http_header("Content-Type: text/plain; charset=UTF-8")

    # インデントと識別子を頼りに、ごく簡単にソースコードを抜き出す
    flag_find = false
    File.read(target).each_line {|line|
      if !flag_find
        if /^  def action_#{part}/ =~ line
          flag_find = true
          puts line
        end
      else
        puts line
        break  if /^  end/ =~ line
      end
    }
  end

end
